require("defines")

local function Round(n)

	return n % 1 >= 0.5 and math.ceil(n) or math.floor(n)

end

local function UBS_placearrow(UBS_table)

	for UBS_var_1 = 1, 1000000 do
		if UBS_table[UBS_var_1] then											--if there is an entry in this spot of the table
			if UBS_table[UBS_var_1].valid then								--if the entity in the table is still valid search for a neighbour
				if not UBS_table[UBS_var_1].neighbours[1] then				--if there is no neighbour
					UBS_var_Active_B_X = UBS_table[UBS_var_1].position.x	--save the X coördinate
					UBS_var_Active_B_Y = UBS_table[UBS_var_1].position.y	--save the Y coördinate
					game.get_surface(1).create_entity{name = "UBS-orange-arrow-with-circle", position = {UBS_var_Active_B_X, UBS_var_Active_B_Y}}		--place the edited arrow at the saved location
					game.players[1].print("Arrows have been placed")
				end																					--if there is a neighbour, do nothing
			end
		else																						--if there is no entry in this spot of the table
			break
		end
	end
end

local function BuildTableBA()

	UBS_table_BA = game.get_surface(1).find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, type = "transport-belt-to-ground"}
	UBS_placearrow(UBS_table_BA)

end

local function BuildTableBTPBTG()

		UBS_table_BB = game.get_surface(1).find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, name = "basic-transport-belt-to-ground"}
		UBS_placearrow(UBS_table_BB)

end

local function BuildTableFTPBTG()

		UBS_table_BF = game.get_surface(1).find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, name= "fast-transport-belt-to-ground"}
		UBS_placearrow(UBS_table_BF)

end

local function BuildTableETPBTG()

		UBS_table_BE = game.get_surface(1).find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, name= "express-transport-belt-to-ground"}
		UBS_placearrow(UBS_table_BE)


end

script.on_event(defines.events.on_tick, function(event)

	if not UBS_var_dns then
		if not UBS_var2 then
			UBS_var2 = 0
		end

		if UBS_var2 == 10 then
			if not game.players[1].gui.left.UBS_frame then
				game.players[1].gui.left.add{type = "frame", name = "UBS_frame", caption = "Do you want to check for disconnected underground belt?", direction = "vertical"}
				game.players[1].gui.left.UBS_frame.add{type = "label", name = "UBS_lbl_warning", caption = "Warning, this might take longer than 2 minutes, depending on the speed of your machine."}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_basic", caption = "Check basic belts"}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_fast", caption = "Check fast belts"}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_express", caption = "Check express belts"}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_all", caption = "Check all belt types"}
				game.players[1].gui.left.UBS_frame.add{type = "button", name = "UBS_button_not", caption = "Close"}
			end
		else
			UBS_var2 = UBS_var2 + 1
		end
	end

	if UBS_var_warningadded then
		if UBS_var3 then
			UBS_var3 = UBS_var3 + 1
		else
			UBS_var3 = 1
		end

		if UBS_var3 == 10 then
			UBS_var_warningadded = false
			BuildTableBA()
			game.players[1].gui.center.UBS_frame_warning.destroy()
		end
	end

	if UBS_var_Active_B_run then																	--check if all the variables have been created and the active search is allowed to run
		if UBS_table_allbelts[UBS_var_Active_B_var_1] then											--if there is an entry in this spot of the table
			if UBS_table_allbelts[UBS_var_Active_B_var_1].valid then								--if the entity in the table is still valid search for a neighbour
				if not UBS_table_allbelts[UBS_var_Active_B_var_1].neighbours[1] then				--if there is no neighbour
					if not UBS_table_Active_B_arrowplaced[UBS_var_Active_B_var_1] then				--if an arrow has already been placed here.
						UBS_var_Active_B_X = UBS_table_allbelts[UBS_var_Active_B_var_1].position.x	--save the X coördinate
						UBS_var_Active_B_Y = UBS_table_allbelts[UBS_var_Active_B_var_1].position.y	--save the Y coördinate
						game.get_surface(1).create_entity{name = "UBS-orange-arrow-with-circle", position = {UBS_var_Active_B_X, UBS_var_Active_B_Y}}		--place the edited arrow at the saved location
						UBS_table_Active_B_arrowplaced[UBS_var_Active_B_var_1] = true				--note that an arrow has been placed (no need to check if the arrow has been placed because the arrow has no collision box)
					end																				--if an arrow has already been placed: do nothing
				end																					--if there is a neighbour, do nothing
			end
		UBS_var_Active_B_var_1 = UBS_var_Active_B_var_1 + 1											--next tick the game will iterate over the next entry
		else																						--if there is no entry in this spot of the table
		UBS_var_Active_B_var_1 = 1																	--the next tick the game will start looking at the start of the table again.
		end
	end

	if UBS_var_Active_P_run then																	--check if all the variables have been created and the active search is allowed to run
		if UBS_table_allpipes[UBS_var_Active_P_var_1] then											--if there is an entry in this spot of the table
			if UBS_table_allpipes[UBS_var_Active_P_var_1].valid then								--if the entity in the table is still valid search for a neighbour
				if not UBS_table_allpipes[UBS_var_Active_P_var_1].neighbours[1] then				--if there is no neighbour
					if not UBS_table_Active_P_arrowplaced[UBS_var_Active_P_var_1] then				--if an arrow has already been placed here.
						UBS_var_Active_B_X = UBS_table_allpipes[UBS_var_Active_P_var_1].position.x	--save the X coördinate
						UBS_var_Active_B_Y = UBS_table_allpipes[UBS_var_Active_P_var_1].position.y	--save the Y coördinate
						game.get_surface(1).create_entity{name = "UBS-orange-arrow-with-circle", position = {UBS_var_Active_B_X, UBS_var_Active_B_Y}}		--place the edited arrow at the saved location
						UBS_table_Active_P_arrowplaced[UBS_var_Active_P_var_1] = true				--note that an arrow has been placed (no need to check if the arrow has been placed because the arrow has no collision box)
					end																				--if an arrow has already been placed: do nothing
				end																					--if there is a neighbour, do nothing
			end
		UBS_var_Active_P_var_1 = UBS_var_Active_P_var_1 + 1											--next tick the game will iterate over the next entry
		else																						--if there is no entry in this spot of the table
		UBS_var_Active_P_var_1 = 1																	--the next tick the game will start looking at the start of the table again.
		end
	end

end)

script.on_event(defines.events.on_gui_click, function(event)
	if event.element.name == "UBS_button_basic" then
		UBS_var_dns = true
		BuildTableBTPBTG()
	elseif event.element.name == "UBS_button_fast" then
		UBS_var_dns = true
		BuildTableFTPBTG()
	elseif event.element.name == "UBS_button_express" then
		UBS_var_dns = true
		BuildTableETPBTG()
	elseif event.element.name == "UBS_button_all" then
		UBS_var_dns = true
		game.players[1].gui.center.add{type = "frame", name = "UBS_frame_warning", caption = "This might take a while"}
		game.players[1].gui.center.UBS_frame_warning.add{type = "label", name = "UBS_lbl_warning1", caption = "This will certainly take a long time, the game is going through 40.000.000.000 tiles three times to check if there are any disconnected underground belts, you better grab some coffee or a snack."}
		UBS_var_warningadded = true
	elseif event.element.name == "UBS_button_not" then
		game.players[1].gui.left.UBS_frame.destroy()
		UBS_var_dns = true
	end
end)

script.on_event(defines.events.on_built_entity, function(event)										--add the entity to the table
	if event.created_entity.type == "transport-belt-to-ground" then									--add all underground belts to one table
		if not UBS_table_allbelts then																--if the table does not yet exist, create it and add the entity and allow the active search to run
			UBS_var_Active_B_run = true																--this will allow the active search to run
			UBS_var_Active_B_var_1 = 1																--this sets the variable that is needed for iterating through the table
			UBS_table_Active_B_arrowplaced = {}														--to track which belts already have (had) a arrow placed on them
			UBS_table_allbelts = {}																	--this creates the table							table and variable creation is done here to not slow down the on_tick event.
			table.insert(UBS_table_allbelts, event.created_entity)
		else																						--if the table does exist, only add the entity
			table.insert(UBS_table_allbelts, event.created_entity)
		end
	elseif event.created_entity.type == "pipe-to-ground" then										--add all underground pipes to one table
		if not UBS_table_allpipes then																--if the table does not yet exist, create it and add the entity and allow the active search to run
			UBS_var_Active_P_run = true																--this will allow the active search to run
			UBS_var_Active_P_var_1 = 1																--this sets the variable that is needed for iterating through the table
			UBS_table_Active_P_arrowplaced = {}														--to track which belts already have (had) a arrow placed on them
			UBS_table_allpipes = {}																	--this creates the table							table and variable creation is done here to not slow down the on_tick event.
			table.insert(UBS_table_allpipes, event.created_entity)
		else																						--if the table does exist, only add the entity
			table.insert(UBS_table_allpipes, event.created_entity)
		end
	end
end)																								--added the entity to the table

script.on_event(defines.events.on_robot_built_entity, function(event)								--add the entity to the table
	if event.created_entity.type == "transport-belt-to-ground" then									--add all underground belts to one table
		if not UBS_table_allbelts then																--if the table does not yet exist, create it and add the entity and allow the active search to run
			UBS_var_Active_B_run = true																--this will allow the active search to run
			UBS_var_Active_B_var_1 = 1																--this sets the variable that is needed for iterating through the table
			UBS_table_Active_B_arrowplaced = {}														--to track which belts already have (had) a arrow placed on them
			UBS_table_allbelts = {}																	--this creates the table							table and variable creation is done here to not slow down the on_tick event.
			table.insert(UBS_table_allbelts, event.created_entity)
		else																						--if the table does exist, only add the entity
			table.insert(UBS_table_allbelts, event.created_entity)
		end
	elseif event.created_entity.type == "pipe-to-ground" then										--add all underground pipes to one table
		if not UBS_table_allpipes then																--if the table does not yet exist, create it and add the entity and allow the active search to run
			UBS_var_Active_P_run = true																--this will allow the active search to run
			UBS_var_Active_P_var_1 = 1																--this sets the variable that is needed for iterating through the table
			UBS_table_Active_P_arrowplaced = {}														--to track which belts already have (had) a arrow placed on them
			UBS_table_allpipes = {}																	--this creates the table							table and variable creation is done here to not slow down the on_tick event.
			table.insert(UBS_table_allpipes, event.created_entity)
		else																						--if the table does exist, only add the entity
			table.insert(UBS_table_allpipes, event.created_entity)
		end
	end
end)																								--added the entity to the table

remote.add_interface("UBS_testcode", {

	test = function()

		UBS_var_test_entity = game.get_surface(1).create_entity{name = "UBS-orange-arrow-with-circle", position = {game.players[1].position.x , game.players[1].position.y}}

	end

} )